﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;

namespace howto_date_files
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            clbRenames.CheckOnClick = true;
        }

        // List the renames that we will perform.
        private void btnSearch_Click(object sender, EventArgs e)
        {
            clbRenames.Items.Clear();

            Directory.SetCurrentDirectory(txtDirectory.Text);

            List<string> new_names = new List<string>();
            string prefix = txtPrefix.Text;
            string format = txtFormat.Text;
            foreach (string filename in Directory.GetFiles(txtDirectory.Text))
            {
                // Get the file's creation date.
                FileInfo file_info = new FileInfo(filename);
                DateTime date = file_info.LastWriteTime.Date;
                string new_name = prefix + date.ToString(format) + file_info.Extension;

                int i = 1;
                while (new_names.Contains(new_name))
                {
                    new_name = prefix + date.ToString(format) +
                        " (" + i.ToString() + ")" + file_info.Extension;
                    i++;
                }
                new_names.Add(new_name);

                clbRenames.Items.Add(file_info.Name + " -> " + new_name);
            }
        }

        // Rename the files.
        private void btnRename_Click(object sender, EventArgs e)
        {
            foreach (object command in clbRenames.CheckedItems)
            {
                string rename = command as string;
                string[] separators = { " -> " };
                string[] names = rename.Split(separators,
                    StringSplitOptions.RemoveEmptyEntries);
                File.Move(names[0], names[1]);
            }

            int num_files = clbRenames.CheckedItems.Count;
            MessageBox.Show("Renamed " + num_files.ToString() + " files");
            clbRenames.Items.Clear();
        }

        private void btnCheckAll_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < clbRenames.Items.Count; i++)
                clbRenames.SetItemCheckState(i, CheckState.Checked);
        }

        private void btnUncheckAll_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < clbRenames.Items.Count; i++)
                clbRenames.SetItemCheckState(i, CheckState.Unchecked);
        }
    }
}
